<section class="result">
  <h3 id="csp">
    <%= if @site.data.csp.pass do %>
    <%= icon(:pass2) %>
    <% else %>
    <%= icon(:fail) %>
    <% end %>
    Content Security Policy
    <%= anchor_link("csp") %>
  </h3>

  <div class="alpha">
    <%= if @site.data.header_csp != "" && @site.data.header_csp != nil do %>
    <p><%= gettext("Content Security Policy set in HTTP header:") %> <code><%= @site.data.header_csp %></code></p>
    <% end %>

    <%= if @site.data.meta_csp do %>
    <p><%= gettext("Content Security Policy set in meta element:") %> <code><%= @site.data.meta_csp %></code></p>
    <% end %>

    <p><%= result_text(@site.data.csp.result) |> raw %></p>

    <%= if @site.data.csp.policy do %>
      <table class="csp data">
        <thead>
          <tr>
            <th class="pass"><%= gettext "Pass" %></th>
            <th class="test"><%= gettext "Test" %></th>
            <th class="info"><%= gettext "Info" %></th>
          </tr>
        </thead>
        <tbody>
          <%= for {policy, value} <- @site.data.csp.policy do %>
            <% {test, pass, info, optional} = csp_policy(policy, value) %>
            <tr>
              <td class="pass" data-label="Pass">
                <%= if pass do %>
                <%= icon(:pass) %> <%= gettext("Yes") %>
                <% else %>
                  <%= if optional do %>
                  <%= icon(:optional) %>
                  <% else %>
                  <%= icon(:fail) %> <%= gettext("No") %>
                  <% end %>
                <% end %>
              </td>
              <td class="test" data-label="Test">
                <%= raw(test) %>
                <p id={Atom.to_string(policy)}>
                  <%= raw(info) %>
                </p>
              </td>

              <td class="info" data-label="Info"><span class="non-button-toggle" role="button" tabindex="0" data-a11y-toggle={Atom.to_string(policy)}><%= gettext("Show") %></span></td>
            </tr>
          <% end %>
        </tbody>
      </table>
    <% end %>
    <aside class="howto">
      <span class="non-button-toggle" role="button" tabindex="0" data-a11y-toggle="howto-csp">
        <%= gettext("How to implement") %>
      </span>

      <div id="howto-csp">
        <p><%= gettext(~s|The recommended way to enable Content Security Policy is with the <code>Content-Security-Policy</code> HTTP header, e.g.:|) |> raw() %></p>

        <p><code>Content-Security-Policy: default-src 'self'</code></p>

        <p><%= gettext(~s|It can also be enabled with an HTML <code>&lt;meta&gt;</code> element:|) |> raw() %></p>

        <p><code>&lt;meta http-equiv="Content-Security-Policy" content="script-src 'self'"&gt;</code></p>

        <p><%= gettext("CSP is a powerful mechanism that we strongly recommend. It allows for very fine-grained control. However, creating a good policy (or adjusting your site to work with a good policy) can take some time and effort. To make this easier, it's possible to use CSP in report-only mode.") %></p>

        <p><%= gettext("See the following pages for more information:") %></p>

        <ul class="default">
          <li><a href="https://developer.mozilla.org/en-US/docs/Web/HTTP/CSP">Content Security Policy (CSP)</a> [developer.mozilla.org]</li>
          <li><a href="https://developers.google.com/web/fundamentals/security/csp/">Google Web Fundamentals: Content Security Policy</a> [developers.google.com]</li>
          <li><a href="https://scotthelme.co.uk/csp-cheat-sheet/">CSP Cheat Sheet</a> [scotthelme.co.uk]</li>
          <li><a href="https://report-uri.com/home/tools">Report URI: Tools</a> (CSP analyser, CSP builder) [report-uri.com]</li>
          <li><a href="https://csp-evaluator.withgoogle.com/">CSP Evaluator</a> [csp-evaluator.withgoogle.com]</li>
          <li><a href="https://www.w3.org/TR/CSP2/">CSP Level 2 specification</a> [w3.org]</li>
          <li><a href="https://www.w3.org/TR/CSP3/">CSP Level 3 specification</a> [w3.org]</li>
          <li><a href="https://caniuse.com/#search=CSP">Browser support</a> [caniuse.com]</li>
        </ul>
      </div>
    </aside>

    <p>
      <small>
      <%= gettext(~s|The Content Security Policy tests are based on the ones from the <a href="https://github.com/mozilla/http-observatory">Mozilla HTTP Observatory</a> scanner/grader project (<a href="https://www.mozilla.org/en-US/MPL/2.0/">Mozilla Public License 2.0</a>) by April King, reimplemented by us for Webbkoll. The explanatory texts are from the <a href="https://observatory.mozilla.org/">Observatory by Mozilla</a> website, <a href="https://creativecommons.org/licenses/by-sa/3.0/">CC-BY-SA 3.0</a>. Any mistake or inaccuracy in the results is our fault.|) |> raw() %>
      </small>
    </p>
  </div>
  <aside class="beta">
    <blockquote>
      <p><%= gettext("Content Security Policy (CSP) is an added layer of security that helps to detect and mitigate certain types of attacks, including Cross Site Scripting (XSS) and data injection attacks. These attacks are used for everything from data theft to site defacement to distribution of malware.") %></p>

      <p><%= gettext("A primary goal of CSP is to mitigate and report XSS attacks. XSS attacks exploit the browser's trust of the content received from the server. Malicious scripts are executed by the victim's browser because the browser trusts the source of the content, even when it's not coming from where it seems to be coming from.") %></p>

      <p><%= gettext("CSP makes it possible for server administrators to reduce or eliminate the vectors by which XSS can occur by specifying the domains that the browser should consider to be valid sources of executable scripts. A CSP compatible browser will then only execute scripts loaded in source files received from those whitelisted domains, ignoring all other script (including inline scripts and event-handling HTML attributes).") %></p>
      <footer>
        &mdash; <cite>MDN: <a href="https://developer.mozilla.org/en-US/docs/Web/HTTP/CSP">Content Security Policy (CSP)</a>, Mozilla Contributors, <a href="http://creativecommons.org/licenses/by-sa/2.5/">CC BY-SA 2.5</a></cite>
      </footer>
    </blockquote>

    <p>
      <%= icon(:law) %>
      <%= gettext "GDPR: " %> <%= [~w|rec 83|, ~w|art 5 5.1.f|, ~w|art 25|, ~w|art 32 32.2|] |> gdpr() |> raw() %><br>
      <%= gettext(~s|GDPR %{art_32_2} makes clear that measures should be taken against unauthorized disclosure of, or access to, personal data transmitted, stored or otherwise processed. CSP is a relatively simple way of ensuring that your web visitors do not end up being put in contact with someone that either they - or you - did not anticipate for them to contact.|, art_32_2: gdpr(~w|art 32 32.2|)) |> raw %>
    </p>
  </aside>
</section>
